## GVariant GVariant — strongly typed value datatype |

## Functions

void | g_variant_unref ()
GVariant * | g_variant_ref ()
GVariant * | g_variant_ref_sink ()
gboolean | g_variant_is_floating ()
GVariant * | g_variant_take_ref ()
const GVariantType * | g_variant_get_type ()
const gchar * | g_variant_get_type_string ()
gboolean | g_variant_is_of_type ()
gboolean | g_variant_is_container ()
gint | g_variant_compare ()
GVariantClass | g_variant_classify ()
gboolean | g_variant_check_format_string ()
void | g_variant_get ()
void | g_variant_get_va ()
GVariant * | g_variant_new ()
GVariant * | g_variant_new_va ()
GVariant * | g_variant_new_boolean ()
GVariant * | g_variant_new_byte ()
GVariant * | g_variant_new_int16 ()
GVariant * | g_variant_new_uint16 ()
GVariant * | g_variant_new_int32 ()
GVariant * | g_variant_new_uint32 ()
GVariant * | g_variant_new_int64 ()
GVariant * | g_variant_new_uint64 ()
GVariant * | g_variant_new_handle ()
GVariant * | g_variant_new_double ()
GVariant * | g_variant_new_string ()
GVariant * | g_variant_new_take_string ()
GVariant * | g_variant_new_printf ()
GVariant * | g_variant_new_object_path ()
gboolean | g_variant_is_object_path ()
GVariant * | g_variant_new_signature ()
gboolean | g_variant_is_signature ()
GVariant * | g_variant_new_variant ()
GVariant * | g_variant_new_strv ()
GVariant * | g_variant_new_objv ()
GVariant * | g_variant_new_bytestring ()
GVariant * | g_variant_new_bytestring_array ()
gboolean | g_variant_get_boolean ()
guchar | g_variant_get_byte ()
gint16 | g_variant_get_int16 ()
guint16 | g_variant_get_uint16 ()
gint32 | g_variant_get_int32 ()
guint32 | g_variant_get_uint32 ()
gint64 | g_variant_get_int64 ()
guint64 | g_variant_get_uint64 ()
gint32 | g_variant_get_handle ()
gdouble | g_variant_get_double ()
const gchar * | g_variant_get_string ()
gchar * | g_variant_dup_string ()
GVariant * | g_variant_get_variant ()
const gchar ** | g_variant_get_strv ()
gchar ** | g_variant_dup_strv ()
const gchar ** | g_variant_get_objv ()
gchar ** | g_variant_dup_objv ()
const gchar * | g_variant_get_bytestring ()
gchar * | g_variant_dup_bytestring ()
const gchar ** | g_variant_get_bytestring_array ()
gchar ** | g_variant_dup_bytestring_array ()
GVariant * | g_variant_new_maybe ()
GVariant * | g_variant_new_array ()
GVariant * | g_variant_new_tuple ()
GVariant * | g_variant_new_dict_entry ()
GVariant * | g_variant_new_fixed_array ()
GVariant * | g_variant_get_maybe ()
gsize | g_variant_n_children ()
GVariant * | g_variant_get_child_value ()
void | g_variant_get_child ()
GVariant * | g_variant_lookup_value ()
gboolean | g_variant_lookup ()
gconstpointer | g_variant_get_fixed_array ()
gsize | g_variant_get_size ()
gconstpointer | g_variant_get_data ()
GBytes * | g_variant_get_data_as_bytes ()
void | g_variant_store ()
GVariant * | g_variant_new_from_data ()
GVariant * | g_variant_new_from_bytes ()
GVariant * | g_variant_byteswap ()
GVariant * | g_variant_get_normal_form ()
gboolean | g_variant_is_normal_form ()
guint | g_variant_hash ()
gboolean | g_variant_equal ()
gchar * | g_variant_print ()
GString * | g_variant_print_string ()
GVariantIter * | g_variant_iter_copy ()
void | g_variant_iter_free ()
gsize | g_variant_iter_init ()
gsize | g_variant_iter_n_children ()
GVariantIter * | g_variant_iter_new ()
GVariant * | g_variant_iter_next_value ()
gboolean | g_variant_iter_next ()
gboolean | g_variant_iter_loop ()
void | g_variant_builder_unref ()
GVariantBuilder * | g_variant_builder_ref ()
GVariantBuilder * | g_variant_builder_new ()
void | g_variant_builder_init ()
void | g_variant_builder_clear ()
void | g_variant_builder_add_value ()
void | g_variant_builder_add ()
void | g_variant_builder_add_parsed ()
GVariant * | g_variant_builder_end ()
void | g_variant_builder_open ()
void | g_variant_builder_close ()
void | g_variant_dict_unref ()
GVariantDict * | g_variant_dict_ref ()
GVariantDict * | g_variant_dict_new ()
void | g_variant_dict_init ()
void | g_variant_dict_clear ()
gboolean | g_variant_dict_contains ()
gboolean | g_variant_dict_lookup ()
GVariant * | g_variant_dict_lookup_value ()
void | g_variant_dict_insert ()
void | g_variant_dict_insert_value ()
gboolean | g_variant_dict_remove ()
GVariant * | g_variant_dict_end ()
#define | G_VARIANT_PARSE_ERROR
GVariant * | g_variant_parse ()
GVariant * | g_variant_new_parsed_va ()
GVariant * | g_variant_new_parsed ()
gchar * | g_variant_parse_error_print_context ()

## Types and Values

| GVariant
enum | GVariantClass
struct | GVariantIter
struct | GVariantBuilder
struct | GVariantDict
enum | GVariantParseError

## Includes

    #include <glib.h>

## Description

GVariant is a variant datatype; it stores a value along with information about the type of that value. The range of possible values is determined by the type. The type system used by GVariant is GVariantType.

GVariant instances always have a type and a value (which are given at construction time). The type and value of a GVariant instance can never change other than by the GVariant itself being destroyed. A GVariant cannot contain a pointer.

GVariant is reference counted using `g_variant_ref()` and `g_variant_unref()`. GVariant also has floating reference counts -- see `g_variant_ref_sink()`.

GVariant is completely threadsafe. A GVariant instance can be concurrently accessed in any way from any number of threads without problems.

GVariant is heavily optimised for dealing with data in serialised form. It works particularly well with data located in memory-mapped files. It can perform nearly all deserialisation operations in a small constant time, usually touching only a single memory page. Serialised GVariant data can also be sent over the network.

GVariant is largely compatible with D-Bus. Almost all types of GVariant instances can be sent over D-Bus. See GVariantType for exceptions. (However, GVariant's serialisation format is not the same as the serialisation format of a D-Bus message body: use GDBusMessage, in the gio library, for those.)

For space-efficiency, the GVariant serialisation format does not automatically include the variant's length, type or endianness, which must either be implied from context (such as knowledge that a particular file format always contains a little-endian `G_VARIANT_TYPE_VARIANT` which occupies the whole length of the file) or supplied out-of-band (for instance, a length, type and/or endianness indicator could be placed at the beginning of a file, network message or network stream).

A GVariant's size is limited mainly by any lower level operating system constraints, such as the number of bits in gsize. For example, it is reasonable to have a 2GB file mapped into memory with GMappedFile, and call `g_variant_new_from_data()` on it.

For convenience to C programmers, GVariant features powerful varargs-based value construction and destruction. This feature is designed to be embedded in other libraries.

There is a Python-inspired text language for describing GVariant values. GVariant includes a printer for this language and a parser with type inferencing.

#### Memory Use

GVariant tries to be quite efficient with respect to memory use. This section gives a rough idea of how much memory is used by the current implementation. The information here is subject to change in the future.

The memory allocated by GVariant can be grouped into 4 broad purposes: memory for serialised data, memory for the type information cache, buffer management memory and memory for the GVariant structure itself.

#### Serialised Data Memory

This is the memory that is used for storing GVariant data in serialised form. This is what would be sent over the network or what would end up on disk, not counting any indicator of the endianness, or of the length or type of the top-level variant.

The amount of memory required to store a boolean is 1 byte. 16, 32 and 64 bit integers and double precision floating point numbers use their "natural" size. Strings (including object path and signature strings) are stored with a nul terminator, and as such use the length of the string plus 1 byte.

Maybe types use no space at all to represent the null value and use the same amount of space (sometimes plus one byte) as the equivalent non-maybe-typed value to represent the non-null case.

Arrays use the amount of space required to store each of their members, concatenated. Additionally, if the items stored in an array are not of a fixed-size (ie: strings, other arrays, etc) then an additional framing offset is stored for each item. The size of this offset is either 1, 2 or 4 bytes depending on the overall size of the container. Additionally, extra padding bytes are added as required for alignment of child values.

Tuples (including dictionary entries) use the amount of space required to store each of their members, concatenated, plus one framing offset (as per arrays) for each non-fixed-sized item in the tuple, except for the last one. Additionally, extra padding bytes are added as required for alignment of child values.

Variants use the same amount of space as the item inside of the variant, plus 1 byte, plus the length of the type string for the item inside the variant.

As an example, consider a dictionary mapping strings to variants. In the case that the dictionary is empty, 0 bytes are required for the serialisation.

If we add an item "width" that maps to the int32 value of 500 then we will use 4 byte to store the int32 (so 6 for the variant containing it) and 6 bytes for the string. The variant must be aligned to 8 after the 6 bytes of the string, so that's 2 extra bytes. 6 (string) + 2 (padding) + 6 (variant) is 14 bytes used for the dictionary entry. An additional 1 byte is added to the array as a framing offset making a total of 15 bytes.

If we add another entry, "title" that maps to a nullable string that happens to have a value of null, then we use 0 bytes for the null value (and 3 bytes for the variant to contain it along with its type string) plus 6 bytes for the string. Again, we need 2 padding bytes. That makes a total of 6 + 2 + 3 = 11 bytes.

We now require extra padding between the two items in the array. After the 14 bytes of the first item, that's 2 bytes required. We now require 2 framing offsets for an extra two bytes. 14 + 2 + 11 + 2 = 29 bytes to encode the entire two-item dictionary.

#### Type Information Cache

For each GVariant type that currently exists in the program a type information structure is kept in the type information cache. The type information structure is required for rapid deserialisation.

Continuing with the above example, if a GVariant exists with the type "a{sv}" then a type information struct will exist for "a{sv}", "{sv}", "s", and "v". Multiple uses of the same type will share the same type information. Additionally, all single-digit types are stored in read-only static memory and do not contribute to the writable memory footprint of a program using GVariant.

Aside from the type information structures stored in read-only memory, there are two forms of type information. One is used for container types where there is a single element type: arrays and maybe types. The other is used for container types where there are multiple element types: tuples and dictionary entries.

Array type info structures are 6 * sizeof (void *), plus the memory required to store the type string itself. This means that on 32-bit systems, the cache entry for "a{sv}" would require 30 bytes of memory (plus malloc overhead).

Tuple type info structures are 6 * sizeof (void *), plus 4 * sizeof (void *) for each item in the tuple, plus the memory required to store the type string itself. A 2-item tuple, for example, would have a type information structure that consumed writable memory in the size of 14 * sizeof (void *) (plus type string) This means that on 32-bit systems, the cache entry for "{sv}" would require 61 bytes of memory (plus malloc overhead).

This means that in total, for our "a{sv}" example, 91 bytes of type information would be allocated.

The type information cache, additionally, uses a GHashTable to store and lookup the cached items and stores a pointer to this hash table in static storage. The hash table is freed when there are zero items in the type cache.

Although these sizes may seem large it is important to remember that a program will probably only have a very small number of different types of values in it and that only one type information structure is required for many different values of the same type.

#### Buffer Management Memory

GVariant uses an internal buffer management structure to deal with the various different possible sources of serialised data that it uses. The buffer is responsible for ensuring that the correct call is made when the data is no longer in use by GVariant. This may involve a `g_free()` or a `g_slice_free()` or even `g_mapped_file_unref()`.

One buffer management structure is used for each chunk of serialised data. The size of the buffer management structure is 4 * (void *). On 32-bit systems, that's 16 bytes.

#### GVariant structure

The size of a GVariant structure is 6 * (void *). On 32-bit systems, that's 24 bytes.

GVariant structures only exist if they are explicitly created with API calls. For example, if a GVariant is constructed out of serialised data for the example given above (with the dictionary) then although there are 9 individual values that comprise the entire dictionary (two keys, two values, two variants containing the values, two dictionary entries, plus the dictionary itself), only 1 GVariant instance exists -- the one referring to the dictionary.

If calls are made to start accessing the other values then GVariant instances will exist for those values only for as long as they are in use (ie: until you call `g_variant_unref()`). The type information is shared. The serialised data and the buffer management structure for that serialised data is shared by the child.

#### Summary

To put the entire example together, for our dictionary mapping strings to variants (with two entries, as given above), we are using 91 bytes of memory for type information, 29 byes of memory for the serialised data, 16 bytes for buffer management and 24 bytes for the GVariant instance, or a total of 160 bytes, plus malloc overhead. If we were to use `g_variant_get_child_value()` to access the two dictionary entries, we would use an additional 48 bytes. If we were to have other dictionaries of the same type, we would use more memory for the serialised data and buffer management for those dictionaries, but the type information would be shared.

## Functions

### g_variant_unref ()

    void
    g_variant_unref (GVariant *value);

Decreases the reference count of `value` . When its reference count drops to 0, the memory used by the variant is freed.

#### Parameters

value | a GVariant |

Since 2.24

### g_variant_ref ()

    GVariant *
    g_variant_ref (GVariant *value);

Increases the reference count of `value` .

#### Parameters

value | a GVariant |

#### Returns

the same `value`

Since 2.24

### g_variant_ref_sink ()

    GVariant *
    g_variant_ref_sink (GVariant *value);

GVariant uses a floating reference count system. All functions with names starting with `g_variant_new_` return floating references.

Calling `g_variant_ref_sink()` on a GVariant with a floating reference will convert the floating reference into a full reference. Calling `g_variant_ref_sink()` on a non-floating GVariant results in an additional normal reference being added.

In other words, if the `value` is floating, then this call "assumes ownership" of the floating reference, converting it to a normal reference. If the `value` is not floating, then this call adds a new normal reference increasing the reference count by one.

All calls that result in a GVariant instance being inserted into a container will call `g_variant_ref_sink()` on the instance. This means that if the value was just created (and has only its floating reference) then the container will assume sole ownership of the value at that point and the caller will not need to unreference it. This makes certain common styles of programming much easier while still maintaining normal refcounting semantics in situations where values are not floating.

#### Parameters

value | a GVariant |

#### Returns

the same `value`

Since 2.24

### g_variant_is_floating ()

    gboolean
    g_variant_is_floating (GVariant *value);

Checks whether `value` has a floating reference count.

This function should only ever be used to assert that a given variant is or is not floating, or for debug purposes. To acquire a reference to a variant that might be floating, always use `g_variant_ref_sink()` or `g_variant_take_ref()`.

See `g_variant_ref_sink()` for more information about floating reference counts.

#### Parameters

value | a GVariant |

#### Returns

whether `value` is floating

Since 2.26

### g_variant_take_ref ()

    GVariant *
    g_variant_take_ref (GVariant *value);

If `value` is floating, sink it. Otherwise, do nothing.

Typically you want to use `g_variant_ref_sink()` in order to automatically do the correct thing with respect to floating or non-floating references, but there is one specific scenario where this function is helpful.

The situation where this function is helpful is when creating an API that allows the user to provide a callback function that returns a GVariant. We certainly want to allow the user the flexibility to return a non-floating reference from this callback (for the case where the value that is being returned already exists).

At the same time, the style of the GVariant API makes it likely that for newly-created GVariant instances, the user can be saved some typing if they are allowed to return a GVariant with a floating reference.

Using this function on the return value of the user's callback allows the user to do whichever is more convenient for them. The caller will alway receives exactly one full reference to the value: either the one that was returned in the first place, or a floating reference that has been converted to a full reference.

This function has an odd interaction when combined with `g_variant_ref_sink()` running at the same time in another thread on the same GVariant instance. If `g_variant_ref_sink()` runs first then the result will be that the floating reference is converted to a hard reference. If `g_variant_take_ref()` runs first then the result will be that the floating reference is converted to a hard reference and an additional reference on top of that one is added. It is best to avoid this situation.

#### Parameters

value | a GVariant |

#### Returns

the same `value`

### g_variant_get_type ()

    const GVariantType *
    g_variant_get_type (GVariant *value);

Determines the type of `value` .

The return value is valid for the lifetime of `value` and must not be freed.

#### Parameters

value | a GVariant |

#### Returns

a GVariantType

Since 2.24

### g_variant_get_type_string ()

    const gchar *
    g_variant_get_type_string (GVariant *value);

Returns the type string of `value` . Unlike the result of calling `g_variant_type_peek_string()`, this string is nul-terminated. This string belongs to GVariant and must not be freed.

#### Parameters

value | a GVariant |

#### Returns

the type string for the type of `value`

Since 2.24

### g_variant_is_of_type ()

    gboolean
    g_variant_is_of_type (GVariant *value,
                          const GVariantType *type);

Checks if a value has a type matching the provided type.

#### Parameters

value | a GVariant instance |
type | a GVariantType |

#### Returns

`TRUE` if the type of `value` matches `type`

Since 2.24

### g_variant_is_container ()

    gboolean
    g_variant_is_container (GVariant *value);

Checks if `value` is a container.

#### Parameters

value | a GVariant instance |

#### Returns

`TRUE` if `value` is a container

Since 2.24

### g_variant_compare ()

    gint
    g_variant_compare (gconstpointer one,
                       gconstpointer two);

Compares `one` and `two` .

The types of `one` and `two` are gconstpointer only to allow use of this function with GTree, GPtrArray, etc. They must each be a GVariant.

Comparison is only defined for basic types (ie: booleans, numbers, strings). For booleans, `FALSE` is less than `TRUE`. Numbers are ordered in the usual way. Strings are in ASCII lexographical order.

It is a programmer error to attempt to compare container values or two values that have types that are not exactly equal. For example, you cannot compare a 32-bit signed integer with a 32-bit unsigned integer. Also note that this function is not particularly well-behaved when it comes to comparison of doubles; in particular, the handling of incomparable values (ie: NaN) is undefined.

If you only require an equality comparison, `g_variant_equal()` is more general.

#### Parameters

one | a basic-typed GVariant instance. | [type GVariant]
two | a GVariant instance of the same type. | [type GVariant]

#### Returns

negative value if a < b; zero if a = b; positive value if a > b.

Since 2.26

### g_variant_classify ()

    GVariantClass
    g_variant_classify (GVariant *value);

Classifies `value` according to its top-level type.

#### Parameters

value | a GVariant |

#### Returns

the GVariantClass of `value`

Since 2.24

### g_variant_check_format_string ()

    gboolean
    g_variant_check_format_string (GVariant *value,
                                   const gchar *format_string,
                                   gboolean copy_only);

Checks if calling `g_variant_get()` with `format_string` on `value` would be valid from a type-compatibility standpoint. `format_string` is assumed to be a valid format string (from a syntactic standpoint).

If `copy_only` is `TRUE` then this function additionally checks that it would be safe to call `g_variant_unref()` on `value` immediately after the call to `g_variant_get()` without invalidating the result. This is only possible if deep copies are made (ie: there are no pointers to the data inside of the soon-to-be-freed GVariant instance). If this check fails then a `g_critical()` is printed and `FALSE` is returned.

This function is meant to be used by functions that wish to provide varargs accessors to GVariant values of uncertain values (eg: `g_variant_lookup()` or `g_menu_model_get_item_attribute()`).

#### Parameters

value | a GVariant |
format_string | a valid GVariant format string |
copy_only | `TRUE` to ensure the format string makes deep copies |

#### Returns

`TRUE` if `format_string` is safe to use

Since 2.34

### g_variant_get ()

    void
    g_variant_get (GVariant *value,
                   const gchar *format_string,
                   ...);

Deconstructs a GVariant instance.

Think of this function as an analogue to `scanf()`.

The arguments that are expected by this function are entirely determined by `format_string` . `format_string` also restricts the permissible types of `value` . It is an error to give a value with an incompatible type. See the section on GVariant format strings. Please note that the syntax of the format string is very likely to be extended in the future.

`format_string` determines the C types that are used for unpacking the values and also determines if the values are copied or borrowed, see the section on GVariant format strings.

#### Parameters

value | a GVariant instance |
format_string | a GVariant format string |
... | arguments, as per `format_string` |

Since 2.24

### g_variant_get_va ()

    void
    g_variant_get_va (GVariant *value,
                      const gchar *format_string,
                      const gchar **endptr,
                      va_list *app);

This function is intended to be used by libraries based on GVariant that want to provide `g_variant_get()`-like functionality to their users.

The API is more general than `g_variant_get()` to allow a wider range of possible uses.

`format_string` must still point to a valid format string, but it only need to be nul-terminated if `endptr` is `NULL`. If `endptr` is non-`NULL` then it is updated to point to the first character past the end of the format string.

`app` is a pointer to a va_list. The arguments, according to `format_string` , are collected from this va_list and the list is left pointing to the argument following the last.

These two generalisations allow mixing of multiple calls to `g_variant_new_va()` and `g_variant_get_va()` within a single actual varargs call by the user.

`format_string` determines the C types that are used for unpacking the values and also determines if the values are copied or borrowed, see the section on GVariant format strings.

#### Parameters

value | a GVariant |
format_string | a string that is prefixed with a format string |
endptr | location to store the end pointer, or `NULL`. | [allow-none][default NULL]
app | a pointer to a va_list |

Since 2.24

### g_variant_new ()

    GVariant *
    g_variant_new (const gchar *format_string,
                   ...);

Creates a new GVariant instance.

Think of this function as an analogue to `g_strdup_printf()`.

The type of the created instance and the arguments that are expected by this function are determined by `format_string` . See the section on GVariant format strings. Please note that the syntax of the format string is very likely to be extended in the future.

The first character of the format string must not be '*' '?' '@' or 'r'; in essence, a new GVariant must always be constructed by this function (and not merely passed through it unmodified).

Note that the arguments must be of the correct width for their types specified in `format_string` . This can be achieved by casting them. See the GVariant varargs documentation.

    1
    2
    3
    4
    5
    6
    7
    8
    MyFlags some_flags = FLAG_ONE | FLAG_TWO;
    const gchar *some_strings[] = { "a", "b", "c", NULL };
    GVariant *new_variant;

    new_variant = g_variant_new ("(t^as)",
                                 /<!-- -->* This cast is required. *<!-- -->/
                                 (guint64) some_flags,
                                 some_strings);

#### Parameters

format_string | a GVariant format string |
... | arguments, as per `format_string` |

#### Returns

a new floating GVariant instance

Since 2.24

### g_variant_new_va ()

    GVariant *
    g_variant_new_va (const gchar *format_string,
                      const gchar **endptr,
                      va_list *app);

This function is intended to be used by libraries based on GVariant that want to provide `g_variant_new()`-like functionality to their users.

The API is more general than `g_variant_new()` to allow a wider range of possible uses.

`format_string` must still point to a valid format string, but it only needs to be nul-terminated if `endptr` is `NULL`. If `endptr` is non-`NULL` then it is updated to point to the first character past the end of the format string.

`app` is a pointer to a va_list. The arguments, according to `format_string` , are collected from this va_list and the list is left pointing to the argument following the last.

Note that the arguments in `app` must be of the correct width for their types specified in `format_string` when collected into the va_list. See the [GVariant varargs documentation][gvariant-varargs.

These two generalisations allow mixing of multiple calls to `g_variant_new_va()` and `g_variant_get_va()` within a single actual varargs call by the user.

The return value will be floating if it was a newly created GVariant instance (for example, if the format string was "(ii)"). In the case that the format_string was '*', '?', 'r', or a format starting with '@' then the collected GVariant pointer will be returned unmodified, without adding any additional references.

In order to behave correctly in all cases it is necessary for the calling function to `g_variant_ref_sink()` the return result before returning control to the user that originally provided the pointer. At this point, the caller will have their own full reference to the result. This can also be done by adding the result to a container, or by passing it to another `g_variant_new()` call.

#### Parameters

format_string | a string that is prefixed with a format string |
endptr | location to store the end pointer, or `NULL`. | [allow-none][default NULL]
app | a pointer to a va_list |

#### Returns

a new, usually floating, GVariant

Since 2.24

### g_variant_new_boolean ()

    GVariant *
    g_variant_new_boolean (gboolean value);

Creates a new boolean GVariant instance -- either `TRUE` or `FALSE`.

#### Parameters

value | a gboolean value |

#### Returns

a floating reference to a new boolean GVariant instance.

[transfer none]

Since 2.24

### g_variant_new_byte ()

    GVariant *
    g_variant_new_byte (guchar value);

Creates a new byte GVariant instance.

#### Parameters

value | a guint8 value |

#### Returns

a floating reference to a new byte GVariant instance.

[transfer none]

Since 2.24

### g_variant_new_int16 ()

    GVariant *
    g_variant_new_int16 (gint16 value);

Creates a new int16 GVariant instance.

#### Parameters

value | a gint16 value |

#### Returns

a floating reference to a new int16 GVariant instance.

[transfer none]

Since 2.24

### g_variant_new_uint16 ()

    GVariant *
    g_variant_new_uint16 (guint16 value);

Creates a new uint16 GVariant instance.

#### Parameters

value | a guint16 value |

#### Returns

a floating reference to a new uint16 GVariant instance.

[transfer none]

Since 2.24

### g_variant_new_int32 ()

    GVariant *
    g_variant_new_int32 (gint32 value);

Creates a new int32 GVariant instance.

#### Parameters

value | a gint32 value |

#### Returns

a floating reference to a new int32 GVariant instance.

[transfer none]

Since 2.24

### g_variant_new_uint32 ()

    GVariant *
    g_variant_new_uint32 (guint32 value);

Creates a new uint32 GVariant instance.

#### Parameters

value | a guint32 value |

#### Returns

a floating reference to a new uint32 GVariant instance.

[transfer none]

Since 2.24

### g_variant_new_int64 ()

    GVariant *
    g_variant_new_int64 (gint64 value);

Creates a new int64 GVariant instance.

#### Parameters

value | a gint64 value |

#### Returns

a floating reference to a new int64 GVariant instance.

[transfer none]

Since 2.24

### g_variant_new_uint64 ()

    GVariant *
    g_variant_new_uint64 (guint64 value);

Creates a new uint64 GVariant instance.

#### Parameters

value | a guint64 value |

#### Returns

a floating reference to a new uint64 GVariant instance.

[transfer none]

Since 2.24

### g_variant_new_handle ()

    GVariant *
    g_variant_new_handle (gint32 value);

Creates a new handle GVariant instance.

By convention, handles are indexes into an array of file descriptors that are sent alongside a D-Bus message. If you're not interacting with D-Bus, you probably don't need them.

#### Parameters

value | a gint32 value |

#### Returns

a floating reference to a new handle GVariant instance.

[transfer none]

Since 2.24

### g_variant_new_double ()

    GVariant *
    g_variant_new_double (gdouble value);

Creates a new double GVariant instance.

#### Parameters

value | a gdouble floating point value |

#### Returns

a floating reference to a new double GVariant instance.

[transfer none]

Since 2.24

### g_variant_new_string ()

    GVariant *
    g_variant_new_string (const gchar *string);

Creates a string GVariant with the contents of `string` .

`string` must be valid utf8.

#### Parameters

string | a normal utf8 nul-terminated string |

#### Returns

a floating reference to a new string GVariant instance.

[transfer none]

Since 2.24

### g_variant_new_take_string ()

    GVariant *
    g_variant_new_take_string (gchar *string);

Creates a string GVariant with the contents of `string` .

`string` must be valid utf8.

This function consumes `string` . `g_free()` will be called on `string` when it is no longer required.

You must not modify or access `string` in any other way after passing it to this function. It is even possible that `string` is immediately freed.

#### Parameters

string | a normal utf8 nul-terminated string |

#### Returns

a floating reference to a new string GVariant instance.

[transfer none]

Since 2.38

### g_variant_new_printf ()

    GVariant *
    g_variant_new_printf (const gchar *format_string,
                          ...);

Creates a string-type GVariant using printf formatting.

This is similar to calling `g_strdup_printf()` and then `g_variant_new_string()` but it saves a temporary variable and an unnecessary copy.

#### Parameters

format_string | a printf-style format string |
... | arguments for `format_string` |

#### Returns

a floating reference to a new string GVariant instance.

[transfer none]

Since 2.38

### g_variant_new_object_path ()

    GVariant *
    g_variant_new_object_path (const gchar *object_path);

Creates a D-Bus object path GVariant with the contents of `string` . `string` must be a valid D-Bus object path. Use `g_variant_is_object_path()` if you're not sure.

#### Parameters

object_path | a normal C nul-terminated string |

#### Returns

a floating reference to a new object path GVariant instance.

[transfer none]

Since 2.24

### g_variant_is_object_path ()

    gboolean
    g_variant_is_object_path (const gchar *string);

Determines if a given string is a valid D-Bus object path. You should ensure that a string is a valid D-Bus object path before passing it to `g_variant_new_object_path()`.

A valid object path starts with '/' followed by zero or more sequences of characters separated by '/' characters. Each sequence must contain only the characters "A-Z[0-9]_". No sequence (including the one following the final '/' character) may be empty.

#### Parameters

string | a normal C nul-terminated string |

#### Returns

`TRUE` if `string` is a D-Bus object path

Since 2.24

### g_variant_new_signature ()

    GVariant *
    g_variant_new_signature (const gchar *signature);

Creates a D-Bus type signature GVariant with the contents of `string` . `string` must be a valid D-Bus type signature. Use `g_variant_is_signature()` if you're not sure.

#### Parameters

signature | a normal C nul-terminated string |

#### Returns

a floating reference to a new signature GVariant instance.

[transfer none]

Since 2.24

### g_variant_is_signature ()

    gboolean
    g_variant_is_signature (const gchar *string);

Determines if a given string is a valid D-Bus type signature. You should ensure that a string is a valid D-Bus type signature before passing it to `g_variant_new_signature()`.

D-Bus type signatures consist of zero or more definite GVariantType strings in sequence.

#### Parameters

string | a normal C nul-terminated string |

#### Returns

`TRUE` if `string` is a D-Bus type signature

Since 2.24

### g_variant_new_variant ()

    GVariant *
    g_variant_new_variant (GVariant *value);

Boxes `value` . The result is a GVariant instance representing a variant containing the original value.

If `child` is a floating reference (see `g_variant_ref_sink()`), the new instance takes ownership of `child` .

#### Parameters

value | a GVariant instance |

#### Returns

a floating reference to a new variant GVariant instance.

[transfer none]

Since 2.24

### g_variant_new_strv ()

    GVariant *
    g_variant_new_strv (const gchar * const *strv,
                        gssize length);

Constructs an array of strings GVariant from the given array of strings.

If `length` is -1 then `strv` is `NULL`-terminated.

#### Parameters

strv | an array of strings. | [array length=length][element-type utf8]
length | the length of `strv` , or -1 |

#### Returns

a new floating GVariant instance.

[transfer none]

Since 2.24

### g_variant_new_objv ()

    GVariant *
    g_variant_new_objv (const gchar * const *strv,
                        gssize length);

Constructs an array of object paths GVariant from the given array of strings.

Each string must be a valid GVariant object path; see `g_variant_is_object_path()`.

If `length` is -1 then `strv` is `NULL`-terminated.

#### Parameters

strv | an array of strings. | [array length=length][element-type utf8]
length | the length of `strv` , or -1 |

#### Returns

a new floating GVariant instance.

[transfer none]

Since 2.30

### g_variant_new_bytestring ()

    GVariant *
    g_variant_new_bytestring (const gchar *string);

Creates an array-of-bytes GVariant with the contents of `string` . This function is just like `g_variant_new_string()` except that the string need not be valid utf8.

The nul terminator character at the end of the string is stored in the array.

#### Parameters

string | a normal nul-terminated string in no particular encoding. | [array zero-terminated=1][element-type guint8]

#### Returns

a floating reference to a new bytestring GVariant instance.

[transfer none]

Since 2.26

### g_variant_new_bytestring_array ()

    GVariant *
    g_variant_new_bytestring_array (const gchar * const *strv,
                                    gssize length);

Constructs an array of bytestring GVariant from the given array of strings.

If `length` is -1 then `strv` is `NULL`-terminated.

#### Parameters

strv | an array of strings. | [array length=length]
length | the length of `strv` , or -1 |

#### Returns

a new floating GVariant instance.

[transfer none]

Since 2.26

### g_variant_get_boolean ()

    gboolean
    g_variant_get_boolean (GVariant *value);

Returns the boolean value of `value` .

It is an error to call this function with a `value` of any type other than `G_VARIANT_TYPE_BOOLEAN`.

#### Parameters

value | a boolean GVariant instance |

#### Returns

`TRUE` or `FALSE`

Since 2.24

### g_variant_get_byte ()

    guchar
    g_variant_get_byte (GVariant *value);

Returns the byte value of `value` .

It is an error to call this function with a `value` of any type other than `G_VARIANT_TYPE_BYTE`.

#### Parameters

value | a byte GVariant instance |

#### Returns

a guchar

Since 2.24

### g_variant_get_int16 ()

    gint16
    g_variant_get_int16 (GVariant *value);

Returns the 16-bit signed integer value of `value` .

It is an error to call this function with a `value` of any type other than `G_VARIANT_TYPE_INT16`.

#### Parameters

value | a int16 GVariant instance |

#### Returns

a gint16

Since 2.24

### g_variant_get_uint16 ()

    guint16
    g_variant_get_uint16 (GVariant *value);

Returns the 16-bit unsigned integer value of `value` .

It is an error to call this function with a `value` of any type other than `G_VARIANT_TYPE_UINT16`.

#### Parameters

value | a uint16 GVariant instance |

#### Returns

a guint16

Since 2.24

### g_variant_get_int32 ()

    gint32
    g_variant_get_int32 (GVariant *value);

Returns the 32-bit signed integer value of `value` .

It is an error to call this function with a `value` of any type other than `G_VARIANT_TYPE_INT32`.

#### Parameters

value | a int32 GVariant instance |

#### Returns

a gint32

Since 2.24

### g_variant_get_uint32 ()

    guint32
    g_variant_get_uint32 (GVariant *value);

Returns the 32-bit unsigned integer value of `value` .

It is an error to call this function with a `value` of any type other than `G_VARIANT_TYPE_UINT32`.

#### Parameters

value | a uint32 GVariant instance |

#### Returns

a guint32

Since 2.24

### g_variant_get_int64 ()

    gint64
    g_variant_get_int64 (GVariant *value);

Returns the 64-bit signed integer value of `value` .

It is an error to call this function with a `value` of any type other than `G_VARIANT_TYPE_INT64`.

#### Parameters

value | a int64 GVariant instance |

#### Returns

a gint64

Since 2.24

### g_variant_get_uint64 ()

    guint64
    g_variant_get_uint64 (GVariant *value);

Returns the 64-bit unsigned integer value of `value` .

It is an error to call this function with a `value` of any type other than `G_VARIANT_TYPE_UINT64`.

#### Parameters

value | a uint64 GVariant instance |

#### Returns

a guint64

Since 2.24

### g_variant_get_handle ()

    gint32
    g_variant_get_handle (GVariant *value);

Returns the 32-bit signed integer value of `value` .

It is an error to call this function with a `value` of any type other than `G_VARIANT_TYPE_HANDLE`.

By convention, handles are indexes into an array of file descriptors that are sent alongside a D-Bus message. If you're not interacting with D-Bus, you probably don't need them.

#### Parameters

value | a handle GVariant instance |

#### Returns

a gint32

Since 2.24

### g_variant_get_double ()

    gdouble
    g_variant_get_double (GVariant *value);

Returns the double precision floating point value of `value` .

It is an error to call this function with a `value` of any type other than `G_VARIANT_TYPE_DOUBLE`.

#### Parameters

value | a double GVariant instance |

#### Returns

a gdouble

Since 2.24

### g_variant_get_string ()

    const gchar *
    g_variant_get_string (GVariant *value,
                          gsize *length);

Returns the string value of a GVariant instance with a string type. This includes the types `G_VARIANT_TYPE_STRING`, `G_VARIANT_TYPE_OBJECT_PATH` and `G_VARIANT_TYPE_SIGNATURE`.

The string will always be utf8 encoded.

If `length` is non-`NULL` then the length of the string (in bytes) is returned there. For trusted values, this information is already known. For untrusted values, a `strlen()` will be performed.

It is an error to call this function with a `value` of any type other than those three.

The return value remains valid as long as `value` exists.

#### Parameters

value | a string GVariant instance |
length | a pointer to a gsize, to store the length. | [allow-none][default 0][out]

#### Returns

the constant string, utf8 encoded.

[transfer none]

Since 2.24

### g_variant_dup_string ()

    gchar *
    g_variant_dup_string (GVariant *value,
                          gsize *length);

Similar to `g_variant_get_string()` except that instead of returning a constant string, the string is duplicated.

The string will always be utf8 encoded.

The return value must be freed using `g_free()`.

#### Parameters

value | a string GVariant instance |
length | a pointer to a gsize, to store the length. | [out]

#### Returns

a newly allocated string, utf8 encoded.

[transfer full]

Since 2.24

### g_variant_get_variant ()

    GVariant *
    g_variant_get_variant (GVariant *value);

Unboxes `value` . The result is the GVariant instance that was contained in `value` .

#### Parameters

value | a variant GVariant instance |

#### Returns

the item contained in the variant.

[transfer full]

Since 2.24

### g_variant_get_strv ()

    const gchar **
    g_variant_get_strv (GVariant *value,
                        gsize *length);

Gets the contents of an array of strings GVariant. This call makes a shallow copy; the return result should be released with `g_free()`, but the individual strings must not be modified.

If `length` is non-`NULL` then the number of elements in the result is stored there. In any case, the resulting array will be `NULL`-terminated.

For an empty array, `length` will be set to 0 and a pointer to a `NULL` pointer will be returned.

#### Parameters

value | an array of strings GVariant |
length | the length of the result, or `NULL`. | [out][allow-none]

#### Returns

an array of constant strings.

[array length=length zero-terminated=1][transfer container]

Since 2.24

### g_variant_dup_strv ()

    gchar **
    g_variant_dup_strv (GVariant *value,
                        gsize *length);

Gets the contents of an array of strings GVariant. This call makes a deep copy; the return result should be released with `g_strfreev()`.

If `length` is non-`NULL` then the number of elements in the result is stored there. In any case, the resulting array will be `NULL`-terminated.

For an empty array, `length` will be set to 0 and a pointer to a `NULL` pointer will be returned.

#### Parameters

value | an array of strings GVariant |
length | the length of the result, or `NULL`. | [out][allow-none]

#### Returns

an array of strings.

[array length=length zero-terminated=1][transfer full]

Since 2.24

### g_variant_get_objv ()

    const gchar **
    g_variant_get_objv (GVariant *value,
                        gsize *length);

Gets the contents of an array of object paths GVariant. This call makes a shallow copy; the return result should be released with `g_free()`, but the individual strings must not be modified.

If `length` is non-`NULL` then the number of elements in the result is stored there. In any case, the resulting array will be `NULL`-terminated.

For an empty array, `length` will be set to 0 and a pointer to a `NULL` pointer will be returned.

#### Parameters

value | an array of object paths GVariant |
length | the length of the result, or `NULL`. | [out][allow-none]

#### Returns

an array of constant strings.

[array length=length zero-terminated=1][transfer container]

Since 2.30

### g_variant_dup_objv ()

    gchar **
    g_variant_dup_objv (GVariant *value,
                        gsize *length);

Gets the contents of an array of object paths GVariant. This call makes a deep copy; the return result should be released with `g_strfreev()`.

If `length` is non-`NULL` then the number of elements in the result is stored there. In any case, the resulting array will be `NULL`-terminated.

For an empty array, `length` will be set to 0 and a pointer to a `NULL` pointer will be returned.

#### Parameters

value | an array of object paths GVariant |
length | the length of the result, or `NULL`. | [out][allow-none]

#### Returns

an array of strings.

[array length=length zero-terminated=1][transfer full]

Since 2.30

### g_variant_get_bytestring ()

    const gchar *
    g_variant_get_bytestring (GVariant *value);

Returns the string value of a GVariant instance with an array-of-bytes type. The string has no particular encoding.

If the array does not end with a nul terminator character, the empty string is returned. For this reason, you can always trust that a non-`NULL` nul-terminated string will be returned by this function.

If the array contains a nul terminator character somewhere other than the last byte then the returned string is the string, up to the first such nul character.

It is an error to call this function with a `value` that is not an array of bytes.

The return value remains valid as long as `value` exists.

#### Parameters

value | an array-of-bytes GVariant instance |

#### Returns

the constant string.

[transfer none][array zero-terminated=1][element-type guint8]

Since 2.26

### g_variant_dup_bytestring ()

    gchar *
    g_variant_dup_bytestring (GVariant *value,
                              gsize *length);

Similar to `g_variant_get_bytestring()` except that instead of returning a constant string, the string is duplicated.

The return value must be freed using `g_free()`.

#### Parameters

value | an array-of-bytes GVariant instance |
length | a pointer to a gsize, to store the length (not including the nul terminator). | [out][allow-none][default NULL]

#### Returns

a newly allocated string.

[transfer full][array zero-terminated=1 length=length][element-type guint8]

Since 2.26

### g_variant_get_bytestring_array ()

    const gchar **
    g_variant_get_bytestring_array (GVariant *value,
                                    gsize *length);

Gets the contents of an array of array of bytes GVariant. This call makes a shallow copy; the return result should be released with `g_free()`, but the individual strings must not be modified.

If `length` is non-`NULL` then the number of elements in the result is stored there. In any case, the resulting array will be `NULL`-terminated.

For an empty array, `length` will be set to 0 and a pointer to a `NULL` pointer will be returned.

#### Parameters

value | an array of array of bytes GVariant ('aay') |
length | the length of the result, or `NULL`. | [out][allow-none]

#### Returns

an array of constant strings.

[array length=length][transfer container]

Since 2.26

### g_variant_dup_bytestring_array ()

    gchar **
    g_variant_dup_bytestring_array (GVariant *value,
                                    gsize *length);

Gets the contents of an array of array of bytes GVariant. This call makes a deep copy; the return result should be released with `g_strfreev()`.

If `length` is non-`NULL` then the number of elements in the result is stored there. In any case, the resulting array will be `NULL`-terminated.

For an empty array, `length` will be set to 0 and a pointer to a `NULL` pointer will be returned.

#### Parameters

value | an array of array of bytes GVariant ('aay') |
length | the length of the result, or `NULL`. | [out][allow-none]

#### Returns

an array of strings.

[array length=length][transfer full]

Since 2.26

### g_variant_new_maybe ()

    GVariant *
    g_variant_new_maybe (const GVariantType *child_type,
                         GVariant *child);

Depending on if `child` is `NULL`, either wraps `child` inside of a maybe container or creates a Nothing instance for the given `type` .

At least one of `child_type` and `child` must be non-`NULL`. If `child_type` is non-`NULL` then it must be a definite type. If they are both non-`NULL` then `child_type` must be the type of `child` .

If `child` is a floating reference (see `g_variant_ref_sink()`), the new instance takes ownership of `child` .

#### Parameters

child_type | the GVariantType of the child, or `NULL`. | [allow-none]
child | the child value, or `NULL`. | [allow-none]

#### Returns

a floating reference to a new GVariant maybe instance.

[transfer none]

Since 2.24

### g_variant_new_array ()

    GVariant *
    g_variant_new_array (const GVariantType *child_type,
                         GVariant * const *children,
                         gsize n_children);

Creates a new GVariant array from `children` .

`child_type` must be non-`NULL` if `n_children` is zero. Otherwise, the child type is determined by inspecting the first element of the `children` array. If `child_type` is non-`NULL` then it must be a definite type.

The items of the array are taken from the `children` array. No entry in the `children` array may be `NULL`.

All items in the array must have the same type, which must be the same as `child_type` , if given.

If the `children` are floating references (see `g_variant_ref_sink()`), the new instance takes ownership of them as if via `g_variant_ref_sink()`.

#### Parameters

child_type | the element type of the new array. | [allow-none]
children | an array of GVariant pointers, the children. | [allow-none][array length=n_children]
n_children | the length of `children` |

#### Returns

a floating reference to a new GVariant array.

[transfer none]

Since 2.24

### g_variant_new_tuple ()

    GVariant *
    g_variant_new_tuple (GVariant * const *children,
                         gsize n_children);

Creates a new tuple GVariant out of the items in `children` . The type is determined from the types of `children` . No entry in the `children` array may be `NULL`.

If `n_children` is 0 then the unit tuple is constructed.

If the `children` are floating references (see `g_variant_ref_sink()`), the new instance takes ownership of them as if via `g_variant_ref_sink()`.

#### Parameters

children | the items to make the tuple out of. | [array length=n_children]
n_children | the length of `children` |

#### Returns

a floating reference to a new GVariant tuple.

[transfer none]

Since 2.24

### g_variant_new_dict_entry ()

    GVariant *
    g_variant_new_dict_entry (GVariant *key,
                              GVariant *value);

Creates a new dictionary entry GVariant. `key` and `value` must be non-`NULL`. `key` must be a value of a basic type (ie: not a container).

If the `key` or `value` are floating references (see `g_variant_ref_sink()`), the new instance takes ownership of them as if via `g_variant_ref_sink()`.

#### Parameters

key | a basic GVariant, the key |
value | a GVariant, the value |

#### Returns

a floating reference to a new dictionary entry GVariant.

[transfer none]

Since 2.24

### g_variant_new_fixed_array ()

    GVariant *
    g_variant_new_fixed_array (const GVariantType *element_type,
                               gconstpointer elements,
                               gsize n_elements,
                               gsize element_size);

Provides access to the serialised data for an array of fixed-sized items.

`value` must be an array with fixed-sized elements. Numeric types are fixed-size as are tuples containing only other fixed-sized types.

`element_size` must be the size of a single element in the array. For example, if calling this function for an array of 32-bit integers, you might say sizeof(gint32). This value isn't used except for the purpose of a double-check that the form of the serialised data matches the caller's expectation.

`n_elements` , which must be non-`NULL` is set equal to the number of items in the array.

#### Parameters

element_type | the GVariantType of each element |
elements | a pointer to the fixed array of contiguous elements |
n_elements | the number of elements |
element_size | the size of each element |

#### Returns

a floating reference to a new array GVariant instance.

[transfer none]

Since 2.32

### g_variant_get_maybe ()

    GVariant *
    g_variant_get_maybe (GVariant *value);

Given a maybe-typed GVariant instance, extract its value. If the value is Nothing, then this function returns `NULL`.

#### Parameters

value | a maybe-typed value |

#### Returns

the contents of `value` , or `NULL`.

[allow-none][transfer full]

Since 2.24

### g_variant_n_children ()

    gsize
    g_variant_n_children (GVariant *value);

Determines the number of children in a container GVariant instance. This includes variants, maybes, arrays, tuples and dictionary entries. It is an error to call this function on any other type of GVariant.

For variants, the return value is always 1. For values with maybe types, it is always zero or one. For arrays, it is the length of the array. For tuples it is the number of tuple items (which depends only on the type). For dictionary entries, it is always 2

This function is O(1).

#### Parameters

value | a container GVariant |

#### Returns

the number of children in the container

Since 2.24

### g_variant_get_child_value ()

    GVariant *
    g_variant_get_child_value (GVariant *value,
                               gsize index_);

Reads a child item out of a container GVariant instance. This includes variants, maybes, arrays, tuples and dictionary entries. It is an error to call this function on any other type of GVariant.

It is an error if `index_` is greater than the number of child items in the container. See `g_variant_n_children()`.

The returned value is never floating. You should free it with `g_variant_unref()` when you're done with it.

This function is O(1).

#### Parameters

value | a container GVariant |
index_ | the index of the child to fetch |

#### Returns

the child at the specified index.

[transfer full]

Since 2.24

### g_variant_get_child ()

    void
    g_variant_get_child (GVariant *value,
                         gsize index_,
                         const gchar *format_string,
                         ...);

Reads a child item out of a container GVariant instance and deconstructs it according to `format_string` . This call is essentially a combination of `g_variant_get_child_value()` and `g_variant_get()`.

`format_string` determines the C types that are used for unpacking the values and also determines if the values are copied or borrowed, see the section on GVariant format strings.

#### Parameters

value | a container GVariant |
index_ | the index of the child to deconstruct |
format_string | a GVariant format string |
... | arguments, as per `format_string` |

Since 2.24

### g_variant_lookup_value ()

    GVariant *
    g_variant_lookup_value (GVariant *dictionary,
                            const gchar *key,
                            const GVariantType *expected_type);

Looks up a value in a dictionary GVariant.

This function works with dictionaries of the type a{s*} (and equally well with type a{o*}, but we only further discuss the string case for sake of clarity).

In the event that `dictionary` has the type a{sv}, the `expected_type` string specifies what type of value is expected to be inside of the variant. If the value inside the variant has a different type then `NULL` is returned. In the event that `dictionary` has a value type other than v then `expected_type` must directly match the key type and it is used to unpack the value directly or an error occurs.

In either case, if `key` is not found in `dictionary` , `NULL` is returned.

If the key is found and the value has the correct type, it is returned. If `expected_type` was specified then any non-`NULL` return value will have this type.

This function is currently implemented with a linear scan. If you plan to do many lookups then GVariantDict may be more efficient.

#### Parameters

dictionary | a dictionary GVariant |
key | the key to lookup in the dictionary |
expected_type | a GVariantType, or `NULL`. | [allow-none]

#### Returns

the value of the dictionary key, or `NULL`.

[transfer full]

Since 2.28

### g_variant_lookup ()

    gboolean
    g_variant_lookup (GVariant *dictionary,
                      const gchar *key,
                      const gchar *format_string,
                      ...);

Looks up a value in a dictionary GVariant.

This function is a wrapper around `g_variant_lookup_value()` and `g_variant_get()`. In the case that `NULL` would have been returned, this function returns `FALSE`. Otherwise, it unpacks the returned value and returns `TRUE`.

`format_string` determines the C types that are used for unpacking the values and also determines if the values are copied or borrowed, see the section on GVariant format strings.

This function is currently implemented with a linear scan. If you plan to do many lookups then GVariantDict may be more efficient.

#### Parameters

dictionary | a dictionary GVariant |
key | the key to lookup in the dictionary |
format_string | a GVariant format string |
... | the arguments to unpack the value into |

#### Returns

`TRUE` if a value was unpacked

Since 2.28

### g_variant_get_fixed_array ()

    gconstpointer
    g_variant_get_fixed_array (GVariant *value,
                               gsize *n_elements,
                               gsize element_size);

Provides access to the serialised data for an array of fixed-sized items.

`value` must be an array with fixed-sized elements. Numeric types are fixed-size, as are tuples containing only other fixed-sized types.

`element_size` must be the size of a single element in the array, as given by the section on serialized data memory.

In particular, arrays of these fixed-sized types can be interpreted as an array of the given C type, with `element_size` set to the size the appropriate type:

- `G_VARIANT_TYPE_INT16` (etc.): gint16 (etc.)

- `G_VARIANT_TYPE_BOOLEAN`: guchar (not gboolean!)

- `G_VARIANT_TYPE_BYTE`: guchar

- `G_VARIANT_TYPE_HANDLE`: guint32

- `G_VARIANT_TYPE_DOUBLE`: gdouble

For example, if calling this function for an array of 32-bit integers, you might say sizeof(gint32). This value isn't used except for the purpose of a double-check that the form of the serialised data matches the caller's expectation.

`n_elements` , which must be non-`NULL` is set equal to the number of items in the array.

#### Parameters

value | a GVariant array with fixed-sized elements |
n_elements | a pointer to the location to store the number of items. | [out]
element_size | the size of each element |

#### Returns

a pointer to the fixed array.

[array length=n_elements][transfer none]

Since 2.24

### g_variant_get_size ()

    gsize
    g_variant_get_size (GVariant *value);

Determines the number of bytes that would be required to store `value` with `g_variant_store()`.

If `value` has a fixed-sized type then this function always returned that fixed size.

In the case that `value` is already in serialised form or the size has already been calculated (ie: this function has been called before) then this function is O(1). Otherwise, the size is calculated, an operation which is approximately O(n) in the number of values involved.

#### Parameters

value | a GVariant instance |

#### Returns

the serialised size of `value`

Since 2.24

### g_variant_get_data ()

    gconstpointer
    g_variant_get_data (GVariant *value);

Returns a pointer to the serialised form of a GVariant instance. The returned data may not be in fully-normalised form if read from an untrusted source. The returned data must not be freed; it remains valid for as long as `value` exists.

If `value` is a fixed-sized value that was deserialised from a corrupted serialised container then `NULL` may be returned. In this case, the proper thing to do is typically to use the appropriate number of nul bytes in place of `value` . If `value` is not fixed-sized then `NULL` is never returned.

In the case that `value` is already in serialised form, this function is O(1). If the value is not already in serialised form, serialisation occurs implicitly and is approximately O(n) in the size of the result.

To deserialise the data returned by this function, in addition to the serialised data, you must know the type of the GVariant, and (if the machine might be different) the endianness of the machine that stored it. As a result, file formats or network messages that incorporate serialised GVariants must include this information either implicitly (for instance "the file always contains a `G_VARIANT_TYPE_VARIANT` and it is always in little-endian order") or explicitly (by storing the type and/or endianness in addition to the serialised data).

#### Parameters

value | a GVariant instance |

#### Returns

the serialised form of `value` , or `NULL`.

[transfer none]

Since 2.24

### g_variant_get_data_as_bytes ()

    GBytes *
    g_variant_get_data_as_bytes (GVariant *value);

Returns a pointer to the serialised form of a GVariant instance. The semantics of this function are exactly the same as `g_variant_get_data()`, except that the returned GBytes holds a reference to the variant data.

#### Parameters

value | a GVariant |

#### Returns

A new GBytes representing the variant data.

[transfer full]

Since 2.36

### g_variant_store ()

    void
    g_variant_store (GVariant *value,
                     gpointer data);

Stores the serialised form of `value` at `data` . `data` should be large enough. See `g_variant_get_size()`.

The stored data is in machine native byte order but may not be in fully-normalised form if read from an untrusted source. See `g_variant_get_normal_form()` for a solution.

As with `g_variant_get_data()`, to be able to deserialise the serialised variant successfully, its type and (if the destination machine might be different) its endianness must also be available.

This function is approximately O(n) in the size of `data` .

#### Parameters

value | the GVariant to store |
data | the location to store the serialised data at |

Since 2.24

### g_variant_new_from_data ()

    GVariant *
    g_variant_new_from_data (const GVariantType *type,
                             gconstpointer data,
                             gsize size,
                             gboolean trusted,
                             GDestroyNotify notify,
                             gpointer user_data);

Creates a new GVariant instance from serialised data.

`type` is the type of GVariant instance that will be constructed. The interpretation of `data` depends on knowing the type.

`data` is not modified by this function and must remain valid with an unchanging value until such a time as `notify` is called with `user_data` . If the contents of `data` change before that time then the result is undefined.

If `data` is trusted to be serialised data in normal form then `trusted` should be `TRUE`. This applies to serialised data created within this process or read from a trusted location on the disk (such as a file installed in /usr/lib alongside your application). You should set trusted to `FALSE` if `data` is read from the network, a file in the user's home directory, etc.

If `data` was not stored in this machine's native endianness, any multi-byte numeric values in the returned variant will also be in non-native endianness. `g_variant_byteswap()` can be used to recover the original values.

`notify` will be called with `user_data` when `data` is no longer needed. The exact time of this call is unspecified and might even be before this function returns.

#### Parameters

type | a definite GVariantType |
data | the serialised data. | [array length=size][element-type guint8]
size | the size of `data` |
trusted | `TRUE` if `data` is definitely in normal form |
notify | function to call when `data` is no longer needed. | [scope async]
user_data | data for `notify` |

#### Returns

a new floating GVariant of type `type` .

[transfer none]

Since 2.24

### g_variant_new_from_bytes ()

    GVariant *
    g_variant_new_from_bytes (const GVariantType *type,
                              GBytes *bytes,
                              gboolean trusted);

Constructs a new serialised-mode GVariant instance. This is the inner interface for creation of new serialised values that gets called from various functions in gvariant.c.

A reference is taken on `bytes` .

#### Parameters

type | a GVariantType |
bytes | a GBytes |
trusted | if the contents of `bytes` are trusted |

#### Returns

a new GVariant with a floating reference.

[transfer none]

Since 2.36

### g_variant_byteswap ()

    GVariant *
    g_variant_byteswap (GVariant *value);

Performs a byteswapping operation on the contents of `value` . The result is that all multi-byte numeric data contained in `value` is byteswapped. That includes 16, 32, and 64bit signed and unsigned integers as well as file handles and double precision floating point values.

This function is an identity mapping on any value that does not contain multi-byte numeric data. That include strings, booleans, bytes and containers containing only these things (recursively).

The returned value is always in normal form and is marked as trusted.

#### Parameters

value | a GVariant |

#### Returns

the byteswapped form of `value` .

[transfer full]

Since 2.24

### g_variant_get_normal_form ()

    GVariant *
    g_variant_get_normal_form (GVariant *value);

Gets a GVariant instance that has the same value as `value` and is trusted to be in normal form.

If `value` is already trusted to be in normal form then a new reference to `value` is returned.

If `value` is not already trusted, then it is scanned to check if it is in normal form. If it is found to be in normal form then it is marked as trusted and a new reference to it is returned.

If `value` is found not to be in normal form then a new trusted GVariant is created with the same value as `value` .

It makes sense to call this function if you've received GVariant data from untrusted sources and you want to ensure your serialised output is definitely in normal form.

#### Parameters

value | a GVariant |

#### Returns

a trusted GVariant.

[transfer full]

Since 2.24

### g_variant_is_normal_form ()

    gboolean
    g_variant_is_normal_form (GVariant *value);

Checks if `value` is in normal form.

The main reason to do this is to detect if a given chunk of serialised data is in normal form: load the data into a GVariant using `g_variant_new_from_data()` and then use this function to check.

If `value` is found to be in normal form then it will be marked as being trusted. If the value was already marked as being trusted then this function will immediately return `TRUE`.

#### Parameters

value | a GVariant instance |

#### Returns

`TRUE` if `value` is in normal form

Since 2.24

### g_variant_hash ()

    guint
    g_variant_hash (gconstpointer value);

Generates a hash value for a GVariant instance.

The output of this function is guaranteed to be the same for a given value only per-process. It may change between different processor architectures or even different versions of GLib. Do not use this function as a basis for building protocols or file formats.

The type of `value` is gconstpointer only to allow use of this function with GHashTable. `value` must be a GVariant.

#### Parameters

value | a basic GVariant value as a gconstpointer. | [type GVariant]

#### Returns

a hash value corresponding to `value`

Since 2.24

### g_variant_equal ()

    gboolean
    g_variant_equal (gconstpointer one,
                     gconstpointer two);

Checks if `one` and `two` have the same type and value.

The types of `one` and `two` are gconstpointer only to allow use of this function with GHashTable. They must each be a GVariant.

#### Parameters

one | a GVariant instance. | [type GVariant]
two | a GVariant instance. | [type GVariant]

#### Returns

`TRUE` if `one` and `two` are equal

Since 2.24

### g_variant_print ()

    gchar *
    g_variant_print (GVariant *value,
                     gboolean type_annotate);

Pretty-prints `value` in the format understood by `g_variant_parse()`.

The format is described here.

If `type_annotate` is `TRUE`, then type information is included in the output.

#### Parameters

value | a GVariant |
type_annotate | `TRUE` if type information should be included in the output |

#### Returns

a newly-allocated string holding the result.

[transfer full]

Since 2.24

### g_variant_print_string ()

    GString *
    g_variant_print_string (GVariant *value,
                            GString *string,
                            gboolean type_annotate);

Behaves as `g_variant_print()`, but operates on a GString.

If `string` is non-`NULL` then it is appended to and returned. Else, a new empty GString is allocated and it is returned.

#### Parameters

value | a GVariant |
string | a GString, or `NULL`. | [allow-none][default NULL]
type_annotate | `TRUE` if type information should be included in the output |

#### Returns

a GString containing the string

Since 2.24

### g_variant_iter_copy ()

    GVariantIter *
    g_variant_iter_copy (GVariantIter *iter);

Creates a new heap-allocated GVariantIter to iterate over the container that was being iterated over by `iter` . Iteration begins on the new iterator from the current position of the old iterator but the two copies are independent past that point.

Use `g_variant_iter_free()` to free the return value when you no longer need it.

A reference is taken to the container that `iter` is iterating over and will be releated only when `g_variant_iter_free()` is called.

#### Parameters

iter | a GVariantIter |

#### Returns

a new heap-allocated GVariantIter.

[transfer full]

Since 2.24

### g_variant_iter_free ()

    void
    g_variant_iter_free (GVariantIter *iter);

Frees a heap-allocated GVariantIter. Only call this function on iterators that were returned by `g_variant_iter_new()` or `g_variant_iter_copy()`.

#### Parameters

iter | a heap-allocated GVariantIter. | [transfer full]

Since 2.24

### g_variant_iter_init ()

    gsize
    g_variant_iter_init (GVariantIter *iter,
                         GVariant *value);

Initialises (without allocating) a GVariantIter. `iter` may be completely uninitialised prior to this call; its old value is ignored.

The iterator remains valid for as long as `value` exists, and need not be freed in any way.

#### Parameters

iter | a pointer to a GVariantIter |
value | a container GVariant |

#### Returns

the number of items in `value`

Since 2.24

### g_variant_iter_n_children ()

    gsize
    g_variant_iter_n_children (GVariantIter *iter);

Queries the number of child items in the container that we are iterating over. This is the total number of items -- not the number of items remaining.

This function might be useful for preallocation of arrays.

#### Parameters

iter | a GVariantIter |

#### Returns

the number of children in the container

Since 2.24

### g_variant_iter_new ()

    GVariantIter *
    g_variant_iter_new (GVariant *value);

Creates a heap-allocated GVariantIter for iterating over the items in `value` .

Use `g_variant_iter_free()` to free the return value when you no longer need it.

A reference is taken to `value` and will be released only when `g_variant_iter_free()` is called.

#### Parameters

value | a container GVariant |

#### Returns

a new heap-allocated GVariantIter.

[transfer full]

Since 2.24

### g_variant_iter_next_value ()

    GVariant *
    g_variant_iter_next_value (GVariantIter *iter);

Gets the next item in the container. If no more items remain then `NULL` is returned.

Use `g_variant_unref()` to drop your reference on the return value when you no longer need it.

Here is an example for iterating with `g_variant_iter_next_value()`:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    // recursively iterate a container
    void
    iterate_container_recursive (GVariant *container)
    {
      GVariantIter iter;
      GVariant *child;

      g_variant_iter_init (&iter, container);
      while ((child = g_variant_iter_next_value (&iter)))
        {
          g_print ("type '%s'\n", g_variant_get_type_string (child));

          if (g_variant_is_container (child))
            iterate_container_recursive (child);

          g_variant_unref (child);
        }
    }

#### Parameters

iter | a GVariantIter |

#### Returns

a GVariant, or `NULL`.

[allow-none][transfer full]

Since 2.24

### g_variant_iter_next ()

    gboolean
    g_variant_iter_next (GVariantIter *iter,
                         const gchar *format_string,
                         ...);

Gets the next item in the container and unpacks it into the variable argument list according to `format_string` , returning `TRUE`.

If no more items remain then `FALSE` is returned.

All of the pointers given on the variable arguments list of this function are assumed to point at uninitialised memory. It is the responsibility of the caller to free all of the values returned by the unpacking process.

Here is an example for memory management with `g_variant_iter_next()`:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    // Iterates a dictionary of type 'a{sv}'
    void
    iterate_dictionary (GVariant *dictionary)
    {
      GVariantIter iter;
      GVariant *value;
      gchar *key;

      g_variant_iter_init (&iter, dictionary);
      while (g_variant_iter_next (&iter, "{sv}", &key, &value))
        {
          g_print ("Item '%s' has type '%s'\n", key,
                   g_variant_get_type_string (value));

          // must free data for ourselves
          g_variant_unref (value);
          g_free (key);
        }
    }

For a solution that is likely to be more convenient to C programmers when dealing with loops, see `g_variant_iter_loop()`.

`format_string` determines the C types that are used for unpacking the values and also determines if the values are copied or borrowed.

See the section on GVariant format strings.

#### Parameters

iter | a GVariantIter |
format_string | a GVariant format string |
... | the arguments to unpack the value into |

#### Returns

`TRUE` if a value was unpacked, or `FALSE` if there as no value

Since 2.24

### g_variant_iter_loop ()

    gboolean
    g_variant_iter_loop (GVariantIter *iter,
                         const gchar *format_string,
                         ...);

Gets the next item in the container and unpacks it into the variable argument list according to `format_string` , returning `TRUE`.

If no more items remain then `FALSE` is returned.

On the first call to this function, the pointers appearing on the variable argument list are assumed to point at uninitialised memory. On the second and later calls, it is assumed that the same pointers will be given and that they will point to the memory as set by the previous call to this function. This allows the previous values to be freed, as appropriate.

This function is intended to be used with a while loop as demonstrated in the following example. This function can only be used when iterating over an array. It is only valid to call this function with a string constant for the format string and the same string constant must be used each time. Mixing calls to this function and `g_variant_iter_next()` or `g_variant_iter_next_value()` on the same iterator causes undefined behavior.

If you break out of a such a while loop using `g_variant_iter_loop()` then you must free or unreference all the unpacked values as you would with `g_variant_get()`. Failure to do so will cause a memory leak.

Here is an example for memory management with `g_variant_iter_loop()`:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    // Iterates a dictionary of type 'a{sv}'
    void
    iterate_dictionary (GVariant *dictionary)
    {
      GVariantIter iter;
      GVariant *value;
      gchar *key;

      g_variant_iter_init (&iter, dictionary);
      while (g_variant_iter_loop (&iter, "{sv}", &key, &value))
        {
          g_print ("Item '%s' has type '%s'\n", key,
                   g_variant_get_type_string (value));

          // no need to free 'key' and 'value' here
          // unless breaking out of this loop
        }
    }

For most cases you should use `g_variant_iter_next()`.

This function is really only useful when unpacking into GVariant or GVariantIter in order to allow you to skip the call to `g_variant_unref()` or `g_variant_iter_free()`.

For example, if you are only looping over simple integer and string types, `g_variant_iter_next()` is definitely preferred. For string types, use the '&' prefix to avoid allocating any memory at all (and thereby avoiding the need to free anything as well).

`format_string` determines the C types that are used for unpacking the values and also determines if the values are copied or borrowed.

See the section on GVariant format strings.

#### Parameters

iter | a GVariantIter |
format_string | a GVariant format string |
... | the arguments to unpack the value into |

#### Returns

`TRUE` if a value was unpacked, or `FALSE` if there was no value

Since 2.24

### g_variant_builder_unref ()

    void
    g_variant_builder_unref (GVariantBuilder *builder);

Decreases the reference count on `builder` .

In the event that there are no more references, releases all memory associated with the GVariantBuilder.

Don't call this on stack-allocated GVariantBuilder instances or bad things will happen.

#### Parameters

builder | a GVariantBuilder allocated by `g_variant_builder_new()`. | [transfer full]

Since 2.24

### g_variant_builder_ref ()

    GVariantBuilder *
    g_variant_builder_ref (GVariantBuilder *builder);

Increases the reference count on `builder` .

Don't call this on stack-allocated GVariantBuilder instances or bad things will happen.

#### Parameters

builder | a GVariantBuilder allocated by `g_variant_builder_new()` |

#### Returns

a new reference to `builder` .

[transfer full]

Since 2.24

### g_variant_builder_new ()

    GVariantBuilder *
    g_variant_builder_new (const GVariantType *type);

Allocates and initialises a new GVariantBuilder.

You should call `g_variant_builder_unref()` on the return value when it is no longer needed. The memory will not be automatically freed by any other call.

In most cases it is easier to place a GVariantBuilder directly on the stack of the calling function and initialise it with `g_variant_builder_init()`.

#### Parameters

type | a container type |

#### Returns

a GVariantBuilder.

[transfer full]

Since 2.24

### g_variant_builder_init ()

    void
    g_variant_builder_init (GVariantBuilder *builder,
                            const GVariantType *type);

Initialises a GVariantBuilder structure.

`type` must be non-`NULL`. It specifies the type of container to construct. It can be an indefinite type such as `G_VARIANT_TYPE_ARRAY` or a definite type such as "as" or "(ii)". Maybe, array, tuple, dictionary entry and variant-typed values may be constructed.

After the builder is initialised, values are added using `g_variant_builder_add_value()` or `g_variant_builder_add()`.

After all the child values are added, `g_variant_builder_end()` frees the memory associated with the builder and returns the GVariant that was created.

This function completely ignores the previous contents of `builder` . On one hand this means that it is valid to pass in completely uninitialised memory. On the other hand, this means that if you are initialising over top of an existing GVariantBuilder you need to first call `g_variant_builder_clear()` in order to avoid leaking memory.

You must not call `g_variant_builder_ref()` or `g_variant_builder_unref()` on a GVariantBuilder that was initialised with this function. If you ever pass a reference to a GVariantBuilder outside of the control of your own code then you should assume that the person receiving that reference may try to use reference counting; you should use `g_variant_builder_new()` instead of this function.

#### Parameters

builder | a GVariantBuilder |
type | a container type |

Since 2.24

### g_variant_builder_clear ()

    void
    g_variant_builder_clear (GVariantBuilder *builder);

Releases all memory associated with a GVariantBuilder without freeing the GVariantBuilder structure itself.

It typically only makes sense to do this on a stack-allocated GVariantBuilder if you want to abort building the value part-way through. This function need not be called if you call `g_variant_builder_end()` and it also doesn't need to be called on builders allocated with g_variant_builder_new (see `g_variant_builder_unref()` for that).

This function leaves the GVariantBuilder structure set to all-zeros. It is valid to call this function on either an initialised GVariantBuilder or one that is set to all-zeros but it is not valid to call this function on uninitialised memory.

#### Parameters

builder | a GVariantBuilder |

Since 2.24

### g_variant_builder_add_value ()

    void
    g_variant_builder_add_value (GVariantBuilder *builder,
                                 GVariant *value);

Adds `value` to `builder` .

It is an error to call this function in any way that would create an inconsistent value to be constructed. Some examples of this are putting different types of items into an array, putting the wrong types or number of items in a tuple, putting more than one value into a variant, etc.

If `value` is a floating reference (see `g_variant_ref_sink()`), the `builder` instance takes ownership of `value` .

#### Parameters

builder | a GVariantBuilder |
value | a GVariant |

Since 2.24

### g_variant_builder_add ()

    void
    g_variant_builder_add (GVariantBuilder *builder,
                           const gchar *format_string,
                           ...);

Adds to a GVariantBuilder.

This call is a convenience wrapper that is exactly equivalent to calling `g_variant_new()` followed by `g_variant_builder_add_value()`.

Note that the arguments must be of the correct width for their types specified in `format_string` . This can be achieved by casting them. See the GVariant varargs documentation.

This function might be used as follows:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    GVariant *
    make_pointless_dictionary (void)
    {
      GVariantBuilder builder;
      int i;

      g_variant_builder_init (&builder, G_VARIANT_TYPE_ARRAY);
      for (i = 0; i < 16; i++)
        {
          gchar buf[3];

          sprintf (buf, "%d", i);
          g_variant_builder_add (&builder, "{is}", i, buf);
        }

      return g_variant_builder_end (&builder);
    }

#### Parameters

builder | a GVariantBuilder |
format_string | a GVariant varargs format string |
... | arguments, as per `format_string` |

Since 2.24

### g_variant_builder_add_parsed ()

    void
    g_variant_builder_add_parsed (GVariantBuilder *builder,
                                  const gchar *format,
                                  ...);

Adds to a GVariantBuilder.

This call is a convenience wrapper that is exactly equivalent to calling `g_variant_new_parsed()` followed by `g_variant_builder_add_value()`.

Note that the arguments must be of the correct width for their types specified in `format_string` . This can be achieved by casting them. See the GVariant varargs documentation.

This function might be used as follows:

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    GVariant *
    make_pointless_dictionary (void)
    {
      GVariantBuilder builder;
      int i;

      g_variant_builder_init (&builder, G_VARIANT_TYPE_ARRAY);
      g_variant_builder_add_parsed (&builder, "{'width', <%i>}", 600);
      g_variant_builder_add_parsed (&builder, "{'title', <%s>}", "foo");
      g_variant_builder_add_parsed (&builder, "{'transparency', <0.5>}");
      return g_variant_builder_end (&builder);
    }

#### Parameters

builder | a GVariantBuilder |
format | a text format GVariant |
... | arguments as per `format` |

Since 2.26

### g_variant_builder_end ()

    GVariant *
    g_variant_builder_end (GVariantBuilder *builder);

Ends the builder process and returns the constructed value.

It is not permissible to use `builder` in any way after this call except for reference counting operations (in the case of a heap-allocated GVariantBuilder) or by reinitialising it with `g_variant_builder_init()` (in the case of stack-allocated).

It is an error to call this function in any way that would create an inconsistent value to be constructed (ie: insufficient number of items added to a container with a specific number of children required). It is also an error to call this function if the builder was created with an indefinite array or maybe type and no children have been added; in this case it is impossible to infer the type of the empty array.

#### Parameters

builder | a GVariantBuilder |

#### Returns

a new, floating, GVariant.

[transfer none]

Since 2.24

### g_variant_builder_open ()

    void
    g_variant_builder_open (GVariantBuilder *builder,
                            const GVariantType *type);

Opens a subcontainer inside the given `builder` . When done adding items to the subcontainer, `g_variant_builder_close()` must be called.

It is an error to call this function in any way that would cause an inconsistent value to be constructed (ie: adding too many values or a value of an incorrect type).

#### Parameters

builder | a GVariantBuilder |
type | a GVariantType |

Since 2.24

### g_variant_builder_close ()

    void
    g_variant_builder_close (GVariantBuilder *builder);

Closes the subcontainer inside the given `builder` that was opened by the most recent call to `g_variant_builder_open()`.

It is an error to call this function in any way that would create an inconsistent value to be constructed (ie: too few values added to the subcontainer).

#### Parameters

builder | a GVariantBuilder |

Since 2.24

### g_variant_dict_unref ()

    void
    g_variant_dict_unref (GVariantDict *dict);

Decreases the reference count on `dict` .

In the event that there are no more references, releases all memory associated with the GVariantDict.

Don't call this on stack-allocated GVariantDict instances or bad things will happen.

#### Parameters

dict | a heap-allocated GVariantDict. | [transfer full]

Since 2.40

### g_variant_dict_ref ()

    GVariantDict *
    g_variant_dict_ref (GVariantDict *dict);

Increases the reference count on `dict` .

Don't call this on stack-allocated GVariantDict instances or bad things will happen.

#### Parameters

dict | a heap-allocated GVariantDict |

#### Returns

a new reference to `dict` .

[transfer full]

Since 2.40

### g_variant_dict_new ()

    GVariantDict *
    g_variant_dict_new (GVariant *from_asv);

Allocates and initialises a new GVariantDict.

You should call `g_variant_dict_unref()` on the return value when it is no longer needed. The memory will not be automatically freed by any other call.

In some cases it may be easier to place a GVariantDict directly on the stack of the calling function and initialise it with `g_variant_dict_init()`. This is particularly useful when you are using GVariantDict to construct a GVariant.

#### Parameters

from_asv | the GVariant with which to initialise the dictionary. | [allow-none]

#### Returns

a GVariantDict.

[transfer full]

Since 2.40

### g_variant_dict_init ()

    void
    g_variant_dict_init (GVariantDict *dict,
                         GVariant *from_asv);

Initialises a GVariantDict structure.

If `from_asv` is given, it is used to initialise the dictionary.

This function completely ignores the previous contents of `dict` . On one hand this means that it is valid to pass in completely uninitialised memory. On the other hand, this means that if you are initialising over top of an existing GVariantDict you need to first call `g_variant_dict_clear()` in order to avoid leaking memory.

You must not call `g_variant_dict_ref()` or `g_variant_dict_unref()` on a GVariantDict that was initialised with this function. If you ever pass a reference to a GVariantDict outside of the control of your own code then you should assume that the person receiving that reference may try to use reference counting; you should use `g_variant_dict_new()` instead of this function.

#### Parameters

dict | a GVariantDict |
from_asv | the initial value for `dict` . | [allow-none]

Since 2.40

### g_variant_dict_clear ()

    void
    g_variant_dict_clear (GVariantDict *dict);

Releases all memory associated with a GVariantDict without freeing the GVariantDict structure itself.

It typically only makes sense to do this on a stack-allocated GVariantDict if you want to abort building the value part-way through. This function need not be called if you call `g_variant_dict_end()` and it also doesn't need to be called on dicts allocated with g_variant_dict_new (see `g_variant_dict_unref()` for that).

It is valid to call this function on either an initialised GVariantDict or one that was previously cleared by an earlier call to `g_variant_dict_clear()` but it is not valid to call this function on uninitialised memory.

#### Parameters

dict | a GVariantDict |

Since 2.40

### g_variant_dict_contains ()

    gboolean
    g_variant_dict_contains (GVariantDict *dict,
                             const gchar *key);

Checks if `key` exists in `dict` .

#### Parameters

dict | a GVariantDict |
key | the key to lookup in the dictionary |

#### Returns

`TRUE` if `key` is in `dict`

Since 2.40

### g_variant_dict_lookup ()

    gboolean
    g_variant_dict_lookup (GVariantDict *dict,
                           const gchar *key,
                           const gchar *format_string,
                           ...);

Looks up a value in a GVariantDict.

This function is a wrapper around `g_variant_dict_lookup_value()` and `g_variant_get()`. In the case that `NULL` would have been returned, this function returns `FALSE`. Otherwise, it unpacks the returned value and returns `TRUE`.

`format_string` determines the C types that are used for unpacking the values and also determines if the values are copied or borrowed, see the section on GVariant format strings.

#### Parameters

dict | a GVariantDict |
key | the key to lookup in the dictionary |
format_string | a GVariant format string |
... | the arguments to unpack the value into |

#### Returns

`TRUE` if a value was unpacked

Since 2.40

### g_variant_dict_lookup_value ()

    GVariant *
    g_variant_dict_lookup_value (GVariantDict *dict,
                                 const gchar *key,
                                 const GVariantType *expected_type);

Looks up a value in a GVariantDict.

If `key` is not found in `dictionary` , `NULL` is returned.

The `expected_type` string specifies what type of value is expected. If the value associated with `key` has a different type then `NULL` is returned.

If the key is found and the value has the correct type, it is returned. If `expected_type` was specified then any non-`NULL` return value will have this type.

#### Parameters

dict | a GVariantDict |
key | the key to lookup in the dictionary |
expected_type | a GVariantType, or `NULL`. | [allow-none]

#### Returns

the value of the dictionary key, or `NULL`.

[transfer full]

Since 2.40

### g_variant_dict_insert ()

    void
    g_variant_dict_insert (GVariantDict *dict,
                           const gchar *key,
                           const gchar *format_string,
                           ...);

Inserts a value into a GVariantDict.

This call is a convenience wrapper that is exactly equivalent to calling `g_variant_new()` followed by `g_variant_dict_insert_value()`.

#### Parameters

dict | a GVariantDict |
key | the key to insert a value for |
format_string | a GVariant varargs format string |
... | arguments, as per `format_string` |

Since 2.40

### g_variant_dict_insert_value ()

    void
    g_variant_dict_insert_value (GVariantDict *dict,
                                 const gchar *key,
                                 GVariant *value);

Inserts (or replaces) a key in a GVariantDict.

`value` is consumed if it is floating.

#### Parameters

dict | a GVariantDict |
key | the key to insert a value for |
value | the value to insert |

Since 2.40

### g_variant_dict_remove ()

    gboolean
    g_variant_dict_remove (GVariantDict *dict,
                           const gchar *key);

Removes a key and its associated value from a GVariantDict.

#### Parameters

dict | a GVariantDict |
key | the key to remove |

#### Returns

`TRUE` if the key was found and removed

Since 2.40

### g_variant_dict_end ()

    GVariant *
    g_variant_dict_end (GVariantDict *dict);

Returns the current value of `dict` as a GVariant of type `G_VARIANT_TYPE_VARDICT`, clearing it in the process.

It is not permissible to use `dict` in any way after this call except for reference counting operations (in the case of a heap-allocated GVariantDict) or by reinitialising it with `g_variant_dict_init()` (in the case of stack-allocated).

#### Parameters

dict | a GVariantDict |

#### Returns

a new, floating, GVariant.

[transfer none]

Since 2.40

### G_VARIANT_PARSE_ERROR

    #define G_VARIANT_PARSE_ERROR (g_variant_parse_error_quark ())

Error domain for GVariant text format parsing. Specific error codes are not currently defined for this domain. See GError for information on error domains.

### g_variant_parse ()

    GVariant *
    g_variant_parse (const GVariantType *type,
                     const gchar *text,
                     const gchar *limit,
                     const gchar **endptr,
                     GError **error);

Parses a GVariant from a text representation.

A single GVariant is parsed from the content of `text` .

The format is described here.

The memory at `limit` will never be accessed and the parser behaves as if the character at `limit` is the nul terminator. This has the effect of bounding `text` .

If `endptr` is non-`NULL` then `text` is permitted to contain data following the value that this function parses and `endptr` will be updated to point to the first character past the end of the text parsed by this function. If `endptr` is `NULL` and there is extra data then an error is returned.

If `type` is non-`NULL` then the value will be parsed to have that type. This may result in additional parse errors (in the case that the parsed value doesn't fit the type) but may also result in fewer errors (in the case that the type would have been ambiguous, such as with empty arrays).

In the event that the parsing is successful, the resulting GVariant is returned.

In case of any error, `NULL` will be returned. If `error` is non-`NULL` then it will be set to reflect the error that occurred.

Officially, the language understood by the parser is "any string produced by `g_variant_print()`".

#### Parameters

type | a GVariantType, or `NULL`. | [allow-none]
text | a string containing a GVariant in text form |
limit | a pointer to the end of `text` , or `NULL`. | [allow-none]
endptr | a location to store the end pointer, or `NULL`. | [allow-none]
error | a pointer to a `NULL` GError pointer, or `NULL`. | [allow-none]

#### Returns

a reference to a GVariant, or `NULL`

### g_variant_new_parsed_va ()

    GVariant *
    g_variant_new_parsed_va (const gchar *format,
                             va_list *app);

Parses `format` and returns the result.

This is the version of `g_variant_new_parsed()` intended to be used from libraries.

The return value will be floating if it was a newly created GVariant instance. In the case that `format` simply specified the collection of a GVariant pointer (eg: `format` was "%*") then the collected GVariant pointer will be returned unmodified, without adding any additional references.

Note that the arguments in `app` must be of the correct width for their types specified in `format` when collected into the va_list. See the GVariant varargs documentation.

In order to behave correctly in all cases it is necessary for the calling function to `g_variant_ref_sink()` the return result before returning control to the user that originally provided the pointer. At this point, the caller will have their own full reference to the result. This can also be done by adding the result to a container, or by passing it to another `g_variant_new()` call.

#### Parameters

format | a text format GVariant |
app | a pointer to a va_list |

#### Returns

a new, usually floating, GVariant

### g_variant_new_parsed ()

    GVariant *
    g_variant_new_parsed (const gchar *format,
                          ...);

Parses `format` and returns the result.

`format` must be a text format GVariant with one extension: at any point that a value may appear in the text, a '%' character followed by a GVariant format string (as per `g_variant_new()`) may appear. In that case, the same arguments are collected from the argument list as `g_variant_new()` would have collected.

Note that the arguments must be of the correct width for their types specified in `format` . This can be achieved by casting them. See the GVariant varargs documentation.

Consider this simple example:

    1
    g_variant_new_parsed ("[('one', 1), ('two', %i), (%s, 3)]", 2, "three");

In the example, the variable argument parameters are collected and filled in as if they were part of the original string to produce the result of

    1
    [('one', 1), ('two', 2), ('three', 3)]

This function is intended only to be used with `format` as a string literal. Any parse error is fatal to the calling process. If you want to parse data from untrusted sources, use `g_variant_parse()`.

You may not use this function to return, unmodified, a single GVariant pointer from the argument list. ie: `format` may not solely be anything along the lines of "%*", "%?", "%r", or anything starting with "%@".

#### Parameters

format | a text format GVariant |
... | arguments as per `format` |

#### Returns

a new floating GVariant instance

### g_variant_parse_error_print_context ()

    gchar *
    g_variant_parse_error_print_context (GError *error,
                                         const gchar *source_str);

Pretty-prints a message showing the context of a GVariant parse error within the string for which parsing was attempted.

The resulting string is suitable for output to the console or other monospace media where newlines are treated in the usual way.

The message will typically look something like one of the following:

    1
    2
    3
    unterminated string constant:
      (1, 2, 3, 'abc
                ^^^^

or

    1
    2
    3
    unable to find a common type:
      [1, 2, 3, 'str']
       ^        ^^^^^

The format of the message may change in a future version.

`error` must have come from a failed attempt to `g_variant_parse()` and `source_str` must be exactly the same string that caused the error. If `source_str` was not nul-terminated when you passed it to `g_variant_parse()` then you must add nul termination before using this function.

#### Parameters

error | a GError from the GVariantParseError domain |
source_str | the string that was given to the parser |

#### Returns

the printed message.

[transfer full]

Since 2.40

## Types and Values

### GVariant

    typedef struct _GVariant GVariant;

GVariant is an opaque data structure and can only be accessed using the following functions.

Since 2.24

### enum GVariantClass

The range of possible top-level types of GVariant instances.

#### Members

G_VARIANT_CLASS_BOOLEAN | The GVariant is a boolean. |
G_VARIANT_CLASS_BYTE | The GVariant is a byte. |
G_VARIANT_CLASS_INT16 | The GVariant is a signed 16 bit integer. |
G_VARIANT_CLASS_UINT16 | The GVariant is an unsigned 16 bit integer. |
G_VARIANT_CLASS_INT32 | The GVariant is a signed 32 bit integer. |
G_VARIANT_CLASS_UINT32 | The GVariant is an unsigned 32 bit integer. |
G_VARIANT_CLASS_INT64 | The GVariant is a signed 64 bit integer. |
G_VARIANT_CLASS_UINT64 | The GVariant is an unsigned 64 bit integer. |
G_VARIANT_CLASS_HANDLE | The GVariant is a file handle index. |
G_VARIANT_CLASS_DOUBLE | The GVariant is a double precision floating point value. |
G_VARIANT_CLASS_STRING | The GVariant is a normal string. |
G_VARIANT_CLASS_OBJECT_PATH | The GVariant is a D-Bus object path string. |
G_VARIANT_CLASS_SIGNATURE | The GVariant is a D-Bus signature string. |
G_VARIANT_CLASS_VARIANT | The GVariant is a variant. |
G_VARIANT_CLASS_MAYBE | The GVariant is a maybe-typed value. |
G_VARIANT_CLASS_ARRAY | The GVariant is an array. |
G_VARIANT_CLASS_TUPLE | The GVariant is a tuple. |
G_VARIANT_CLASS_DICT_ENTRY | The GVariant is a dictionary entry. |

Since 2.24

### struct GVariantIter

    struct GVariantIter {
    };

GVariantIter is an opaque data structure and can only be accessed using the following functions.

### struct GVariantBuilder

    struct GVariantBuilder {
    };

A utility type for constructing container-type GVariant instances.

This is an opaque structure and may only be accessed using the following functions.

GVariantBuilder is not threadsafe in any way. Do not attempt to access it from more than one thread.

### struct GVariantDict

    struct GVariantDict {
    };

GVariantDict is a mutable interface to GVariant dictionaries.

It can be used for doing a sequence of dictionary lookups in an efficient way on an existing GVariant dictionary or it can be used to construct new dictionaries with a hashtable-like interface. It can also be used for taking existing dictionaries and modifying them in order to create new ones.

GVariantDict can only be used with `G_VARIANT_TYPE_VARDICT` dictionaries.

It is possible to use GVariantDict allocated on the stack or on the heap. When using a stack-allocated GVariantDict, you begin with a call to `g_variant_dict_init()` and free the resources with a call to `g_variant_dict_clear()`.

Heap-allocated GVariantDict follows normal refcounting rules: you allocate it with `g_variant_dict_new()` and use `g_variant_dict_ref()` and `g_variant_dict_unref()`.

g_variant_dict_end() is used to convert the GVariantDict back into a dictionary-type GVariant. When used with stack-allocated instances, this also implicitly frees all associated memory, but for heap-allocated instances, you must still call `g_variant_dict_unref()` afterwards.

You will typically want to use a heap-allocated GVariantDict when you expose it as part of an API. For most other uses, the stack-allocated form will be more convenient.

Consider the following two examples that do the same thing in each style: take an existing dictionary and look up the "count" uint32 key, adding 1 to it if it is found, or returning an error if the key is not found. Each returns the new dictionary as a floating GVariant.

#### Using a stack-allocated GVariantDict

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    GVariant *
    add_to_count (GVariant  *orig,
                  GError   **error)
    {
      GVariantDict dict;
      guint32 count;

      g_variant_dict_init (&dict, orig);
      if (!g_variant_dict_lookup (&dict, "count", "u", &count))
        {
          g_set_error (...);
          g_variant_dict_clear (&dict);
          return NULL;
        }

      g_variant_dict_insert (&dict, "count", "u", count + 1);

      return g_variant_dict_end (&dict);
    }

#### Using heap-allocated GVariantDict

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    GVariant *
    add_to_count (GVariant  *orig,
                  GError   **error)
    {
      GVariantDict *dict;
      GVariant *result;
      guint32 count;

      dict = g_variant_dict_new (orig);

      if (g_variant_dict_lookup (dict, "count", "u", &count))
        {
          g_variant_dict_insert (dict, "count", "u", count + 1);
          result = g_variant_dict_end (dict);
        }
      else
        {
          g_set_error (...);
          result = NULL;
        }

      g_variant_dict_unref (dict);

      return result;
    }

Since 2.40

### enum GVariantParseError

Error codes returned by parsing text-format GVariants.

#### Members

G_VARIANT_PARSE_ERROR_FAILED | generic error (unused) |
G_VARIANT_PARSE_ERROR_BASIC_TYPE_EXPECTED | a non-basic GVariantType was given where a basic type was expected |
G_VARIANT_PARSE_ERROR_CANNOT_INFER_TYPE | cannot infer the GVariantType |
G_VARIANT_PARSE_ERROR_DEFINITE_TYPE_EXPECTED | an indefinite GVariantType was given where a definite type was expected |
G_VARIANT_PARSE_ERROR_INPUT_NOT_AT_END | extra data after parsing finished |
G_VARIANT_PARSE_ERROR_INVALID_CHARACTER | invalid character in number or unicode escape |
G_VARIANT_PARSE_ERROR_INVALID_FORMAT_STRING | not a valid GVariant format string |
G_VARIANT_PARSE_ERROR_INVALID_OBJECT_PATH | not a valid object path |
G_VARIANT_PARSE_ERROR_INVALID_SIGNATURE | not a valid type signature |
G_VARIANT_PARSE_ERROR_INVALID_TYPE_STRING | not a valid GVariant type string |
G_VARIANT_PARSE_ERROR_NO_COMMON_TYPE | could not find a common type for array entries |
G_VARIANT_PARSE_ERROR_NUMBER_OUT_OF_RANGE | the numerical value is out of range of the given type |
G_VARIANT_PARSE_ERROR_NUMBER_TOO_BIG | the numerical value is out of range for any type |
G_VARIANT_PARSE_ERROR_TYPE_ERROR | cannot parse as variant of the specified type |
G_VARIANT_PARSE_ERROR_UNEXPECTED_TOKEN | an unexpected token was encountered |
G_VARIANT_PARSE_ERROR_UNKNOWN_KEYWORD | an unknown keyword was encountered |
G_VARIANT_PARSE_ERROR_UNTERMINATED_STRING_CONSTANT | unterminated string constant |
G_VARIANT_PARSE_ERROR_VALUE_EXPECTED | no value given |

## See Also

GVariantType